=== debian/tests/control ===
Tests: upstream-testsuite
Depends: @builddeps@, binutils, linux-libc-dev [linux-any], gcc
Restrictions: allow-stderr, needs-sudo
