=== debian/watch ===
version=3
opts=pgpmode=auto \
https://ftp.gnu.org/gnu/glibc/glibc-([\d\.]+)\.tar\.xz debian uupdate
